<#ibiztemplate>
TARGET=PSSYSAPP
</#ibiztemplate>
{
  "name": "app",
  "version": "0.1.0",
  "private": true,
  "scripts": {
    "serve": "node --max_old_space_size=8102 ./node_modules/@vue/cli-service/bin/vue-cli-service serve --mode test",
    "dev-serve": "node --max_old_space_size=8102 ./node_modules/@vue/cli-service/bin/vue-cli-service serve --mode development",
    "build": "node --max_old_space_size=8102 ./node_modules/@vue/cli-service/bin/vue-cli-service build",
    "dev-build": "node --max_old_space_size=8102 ./node_modules/@vue/cli-service/bin/vue-cli-service build --mode development",
    "test:unit": "vue-cli-service test:unit",
    "test:e2e": "vue-cli-service test:e2e",
    "lint": "vue-cli-service lint"
  },
  "dependencies": {
    "@fullcalendar/core": "^4.4.0",
    "@fullcalendar/daygrid": "^4.4.0",
    "@fullcalendar/interaction": "^4.4.0",
    "@fullcalendar/list": "^4.4.0",
    "@fullcalendar/timegrid": "^4.4.0",
    "@fullcalendar/vue": "^4.4.0",
    "vuedraggable": "^2.23.2",
    "async-validator": "^3.3.0",
    "@popperjs/core": "^2.4.3",
    "axios": "^0.19.1",
    "core-js": "^3.4.4",
    "echarts": "^4.6.0",
    "element-ui": "^2.13.0",
    "file-saver": "^2.0.2",
    "font-awesome": "^4.7.0",
    "ibiz-gantt-elastic": "^1.0.17",
    "ibiz-vue-lib": "^0.1.13",
    "interactjs": "^1.9.4",
    "moment": "^2.24.0",
    "path-to-regexp": "^6.1.0",
    "qs": "^6.9.1",
    "rxjs": "^6.5.4",
    "tinymce": "4.8.5",
    "view-design": "4.2.0",
    "vue": "^2.6.10",
    "vue-class-component": "^7.0.2",
    "vue-grid-layout": "^2.3.7",
    "vue-i18n": "^8.15.3",
    "vue-property-decorator": "^8.3.0",
    "vue-router": "^3.1.3",
    "vuex": "^3.1.2",
  <#if app.getAllPSAppPkgs?? && app.getAllPSAppPkgs()??>
    <#list app.getAllPSAppPkgs() as appPackage>
    <#if appPackage.getVerParam()??>${appPackage.getVerParam()}</#if>,
    </#list>
  </#if>
    "xlsx": "^0.15.6"
  },
  "devDependencies": {
    "@types/echarts": "^4.4.3",
    "@types/jest": "^24.0.19",
    "@types/mockjs": "^1.0.2",
    "@types/qs": "^6.9.0",
    "@vue/cli-plugin-babel": "^4.1.0",
    "@vue/cli-plugin-e2e-cypress": "^4.1.0",
    "@vue/cli-plugin-router": "^4.1.0",
    "@vue/cli-plugin-typescript": "^4.1.0",
    "@vue/cli-plugin-unit-jest": "^4.1.0",
    "@vue/cli-plugin-vuex": "^4.1.0",
    "@vue/cli-service": "^4.1.0",
    "@vue/test-utils": "1.0.0-beta.29",
    "axios-mock-adapter": "^1.17.0",
    "compression-webpack-plugin": "^4.0.0",
    "less": "^3.0.4",
    "less-loader": "^5.0.0",
    "mockjs": "^1.1.0",
    "script-loader": "^0.7.2",
    "typescript": "~3.5.3",
  <#if app.getAllPSAppPkgs?? && app.getAllPSAppPkgs()??>
    <#list app.getAllPSAppPkgs() as appPackage>
    <#if appPackage.getVerParam()2??>${appPackage.getVerParam2()}</#if>,
    </#list>
  </#if>
    "vue-template-compiler": "^2.6.10"
  }
}
